% 'Simulation_TID.m' is a function for generating the Type 1 diabetes data.
% One can select each of the genes listed below, and the default one is IFIH1.

function [Simu_asp]=Simulation_DIT(Num_ind);
%% Number of mutation for each gene
%% IFIH1 gene 
qA=[12 9 7 6 4 3 3 2 2 2 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0];
qU=[15 7 23 12 2 24 5 4 0 2 0 1 4 1 0 0 0 0 0 2 1 1 1 1 1 1 1 1 1];
%% AIRE gene
%qA=[16 12 10 8 8 7 4 3 3 2 2 2 1 1 0 0 0 0];
%qU=[21 21 12 10 10 1 3 1 3 0 1 0 0 0 2 3 3 1];
%% CLEC16A gene
%qA=[21 10 6 5 4 3 3 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
%qU=[24 24 4 17 1 0 2 2 5 3 3 0 0 1 0 5 1 3 1 0 0 0 0 0 0 2 0 0 0 0 0 1 1 1 1 1 3 1 1 1 1 2 1 1 1];
%% FOXP3 gene
%qA=[31 2 2 1 1 1 0];
%qU=[26 3 2 1 0 0 3];
%% IAN4L1 gene
%qA=[23 3 1 1 1 0 0];
%qU=[27 4 3 0 0 1 1];
%% IL2RA gene
%qA=[23 23 21 19 3 2 2 2 1 1 1 1 1 0 0 0 0 0 0 0];
%qU=[28 25 25 26 0 3 0 2 1 0 1 0 0 1 1 1 3 1 1 1];
%% KCNJ11 gene
%qA=[17 17 3 1];
%qU=[22 14 6 0];
%% PTPN2 gene
%qA=[1 1 1 1 0 0 0];
%qU=[4 0 0 1 1 1 1];
%% PTPN22 gene
%qA=[14 14 10 4 3 2 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0];
%qU=[17 19 7 2 3 2 0 0 2 0 0 0 3 0 1 0 0 0 0 0 0 2 1 1 1 1 1 2 2 1 1 1 1];
%% SH2B3 gene
%qA=[4 1 1 1 0 0 0 0 0];
%qU=[1 0 0 1 3 1 1 1 1 ];

Affected=zeros(Num_ind,length(qU));
Unaffected=zeros(Num_ind,length(qU));

for j=1:length(qU) 
    U=0;
    while U~=qU(j) % The observed number of mutation at each variant is fixed at each value observed in the original study.
       for i=1:Num_ind
           % Generate genotypes for controls
           Unaffected(i,j)=randsample([2 1 0],1, true, [(qU(j)/(2*Num_ind))^2 2*(qU(j)/(2*Num_ind))*(1-qU(j)/(2*Num_ind)) (1-qU(j)/(2*Num_ind))^2]);
           U=sum(Unaffected(:,j));
       end
    end
    A=0;
    while A~=qA(j)
       for i=1:Num_ind
            % Generate genotypes for cases
           Affected(i,j)=randsample([2 1 0],1, true, [(qA(j)/(2*Num_ind))^2 2*(qA(j)/(2*Num_ind))*(1-qA(j)/(2*Num_ind)) (1-qA(j)/(2*Num_ind))^2]);
           A=sum(Affected(:,j));
       end
    end
end
% Creat phenotypes for cases and controls
Affected(: ,length(qU)+2)=1;
Unaffected(:,length(qU)+2)=0; 
Simu_asp=[Affected; Unaffected];
